// qrand.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include "qrand.h"

#if defined(__cplusplus)
extern "C" {
#endif

HCRYPTPROV g_hProv;

QRAND_API int version(void){
	return QRAND_VERSION;
}

QRAND_API int qrand(void)
{
	int buff;
	::CryptGenRandom(g_hProv, sizeof(int), (BYTE *)&buff);
	return buff;
}

QRAND_API int dice(int max)
{
	if (max < 1)
	{
		return 0;
	}
	DWORD rand = (DWORD)qrand();
	return (int)((rand % max) + 1);
}

void Initialize(){
	::CryptAcquireContext(&g_hProv, NULL, NULL, PROV_RSA_FULL, 0);
}
void Release(){
	::CryptReleaseContext(g_hProv, 0);
}
#if defined(__cplusplus)
}
#endif
